<template>
  <vxe-modal v-model="dialogVisible" title="前方需求计划" width="1450" height="auto" remember>
    <el-container>
      <el-header style="width: 100%; height: 35px;font-size: 12px">
        <el-form :inline="true"  label-width="45px"  label-position="left">
          <el-row >
            <el-col :span="15" >
              <el-form-item label="船号:">
                <vxe-pulldown ref="xDown4" transfer >
                  <template #default>
                    <vxe-input
                      v-model="queryParam.dcCh"
                      placeholder="船号"
                      style="height: 28px;
                    line-height: 28px; width: 150px;"
                      suffix-icon="vxe-icon--search"
                      @keyup="keyupEvent4"
                      @focus="focusEvent4"
                    />
                  </template>
                  <template #dropdown>
                    <div class="my-dropdown  mytable " style="width: 250px">
                      <vxe-grid
                        highlight-hover-row
                        height="auto"
                        :data="projectData"
                        :columns="projectColumns"
                        @cell-click="cellClickEvent"
                        show-overflow
                      >
                        <template #wgbsEdit="{ row}">
                          <vxe-checkbox v-model="row.wgbs"  checked-value="Y" unchecked-value="N"   disabled ></vxe-checkbox>
                        </template>
                      </vxe-grid>
                    </div>
                  </template>
                </vxe-pulldown>
              </el-form-item>
              <el-form-item label="批量:">
                <el-input v-model="queryParam.dcPl" type="search" placeholder="批量" ></el-input>
              </el-form-item>
              <el-form-item label="分段:">
                <el-input v-model="queryParam.dcFd" type="search" placeholder="分段" ></el-input>
              </el-form-item>
            </el-col>
            <el-col :span="9" >
              <el-form-item style="float: right" >
                <el-button type="success" @click="initList">查询</el-button>
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
      </el-header>
      <el-container  style="padding-top: 0px">
        <el-main>
          <div class="mytable">
            <vxe-grid
              id="id"
              ref="xGrid"
              border
              resizable
              keep-source
              :align="'center'"
              :height="height"
              :auto-resize="true"
              :columns="tableColumn"
              :data="list"
              @cell-dblclick="dblclick"
              :custom-config="{ storage: true }"
              highlight-current-row
              highlight-hover-row
              show-overflow
            >
            </vxe-grid>
          </div>
        </el-main>
      </el-container>
    </el-container>
  </vxe-modal>
</template>
<script>
import { mapGetters } from 'vuex'
import XEUtils from 'xe-utils'
import { getToken } from '@/utils/auth'
import ScrollPane from "@/layout/components/TagsView/ScrollPane.vue";
import {endLoading, startLoading} from "@/utils";
import {Message} from "element-ui";

import {getCzxx, getQfxq} from '@/api/jhzx/qfxq'
import {getCzplBase} from "@/api/sjzx/jcsj";
import {getLjxx} from "@/api/jhzxgl/ypp";
export default {
  name:'YppTq',
  components: {ScrollPane},
  data() {
    return {
      dialogVisible:false,
      queryParam: {
        dcCh:'',
        dcPl:'',
        dcFd:'',
        zt:'2',
        fan:'1'
      },
      projectData:[],
      projectData1:[],
      monthList:[],
      list: [],
      checkedList: [],
      dictData:[],
      height: '500px',
      projectColumns: [
        {field: 'cbbm', title: '船号',width: 110},
        { field: 'wgbs', title: '完工标识', width: 80,
          slots:{
            default: 'wgbsEdit'
          },
        },
      ],
      tableColumn:[
        { field: 'dcCh', title: '船只', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'dcPl', title: '批量', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'zdh', title: '总段号', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'dcFd', title: '分段号', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'dzjz', title: '大组极重', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'zxfdxq', title: '总装部最新分段需求期', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xzglxq', title: '钢料需求（小组）', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'dzglxq', title: '钢料需求（大组）', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xdb', title: 'X大板', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xskj', title: 'X数控件', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xpt', title: 'X平铁', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xyw', title: 'X压弯', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xxc', title: 'X型材', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xtxc', title: 'X二次装T型材', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'ddb', title: 'D大板', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'dqb', title: 'D曲板', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'dxc', title: 'D型材T', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'dsj', title: 'D散件', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xqzt', title: '需求状态', width: 120,formatter:this.formatterZt,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'drcs', title: '导入次数', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'xzglxqOld', title: '原需求期', width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },

      ],
      tableColumn2:[
        { field: 'dcCh', title: '船只', width: 200,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        }
      ],
      isupload:'02',
      uploadData:{},
      heads: { token: getToken() },
      uploadAction: process.env.VUE_APP_BASE_API + '/dmSygdxq/upload',
    }
  },
  computed: {
    ...mapGetters(['name', 'bmbm'])
  },
  created() {
    window.addEventListener('resize', this.getHeight)
    this.getHeight()
    this.initBase()
    this.initProject()
  },
  methods: {
    dblclick({row}){
      getLjxx(row).then(res=>{
        if (res.data.length>0){
          this.$emit('add',res.data)
          this.dialogVisible=false
          return;
        }
        this.$message.warning('暂无零件数据')
      })
    },
    show(){
      this.dialogVisible=true
    },
    initProject(){
      getCzplBase({}).then(res=>{
        this.projectData=res.data.cbbm
        this.projectData1=res.data.cbbm
      })
    },
    cellClickEvent({row}){
      this.queryParam.dcCh = row.cbbm
      this.$refs.xDown4.hidePanel()
    },
    focusEvent4(){
      this.$refs.xDown4.showPanel()
    },
    keyupEvent4(){
      if (this.queryParam.dcCh) {
        this.projectData = this.projectData1.filter(row => row.cbbm.indexOf(this.queryParam.dcCh.toUpperCase()) > -1)
      } else {
        this.projectData = this.projectData1.slice(0)
      }
    },
    //转码
    formatterZt({cellValue}){
      if(cellValue==='0'){
        return '正常'
      }
      if(cellValue==='1'){
        return '提前'
      }
      if (cellValue==='2'){
        return '拖期'
      }
      return cellValue
    },
    footerMethod({ columns, data }){
      return [
        columns.map((column, columnIndex) => {
          if (columnIndex === 0) {
            return '合计'
          }
          return this.sumNum(data, column.property)
        })
      ]
    },
    sumNum(list, field) {
      let count = 0
      list.forEach(item => {
        let num = Number(item[field])
        if (!XEUtils.isNumber(num) || isNaN(num)) {
          num = 0
        }
        count = this.cal.accAdd(count, num)
      })
      return count
    },
    uploadExcel() {
      this.uploadData.isupload = this.isupload
    },
    beforeAvatarUpload(file) {
      // 文件类型
      const isType = file.type === 'application/vnd.ms-excel'
      const isTypeComputer = file.type === 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
      const fileType = isType || isTypeComputer
      // if (!fileType) {
      //   this.$message.error('上传文件只能是xls/xlsx格式！')
      //   return
      // }
      startLoading()
      return fileType
    },
    handleAvatarSuccess(res, file) {
      endLoading()
      if (res.success) {
        this.$message({ message: '导入成功', type: 'success' })
        this.initList();

      } else {
        Message({
          message: res.message || 'Error',
          type: 'error',
          duration: 5 * 1000
        })
      }
    },
    //合并行
    rowspanMethod({ row, _rowIndex, column, visibleData }){
      //不要忘记在vxe-grid上配置  :scroll-y="{enabled: false}" 防止下拉时样式变化
      // 需要合并的列字段
      let fields = ['nf','yf','rq','tzxqq'];// 需要合并的列
      const cellValue = row[column.property];// 合并行的相同的唯一标识
      if (cellValue && fields.includes(column.property)) {
        const prevRow = visibleData[_rowIndex - 1];
        let nextRow = visibleData[_rowIndex + 1];
        if (prevRow && prevRow[column.property] === cellValue) {
          // 如果和第一行数据一样，就删除
          return { rowspan: 0, colspan: 0 };
        } else {
          // 获取有机会数据是一样的
          let countRowspan = 1;
          while (nextRow && nextRow[column.property] === cellValue) {
            nextRow = visibleData[++countRowspan + _rowIndex];
          }
          if (countRowspan > 1) {
            return { rowspan: countRowspan, colspan: 1 };
          }
        }
      }
    },
    //转码信息
    initBase(){
      getCzxx({}).then(res=>{
        this.dictData = res.data
      })
    },
    //初始化表1 数据
    initList() {
      if (this.queryParam.dcCh === '') {
        this.$message.warning('选择船号')
        return
      }

      getQfxq(this.queryParam).then((res) => {
        if (res.data){
          this.list = res.data
        }
      })
    },
    formatDate ({ cellValue }) {
      return XEUtils.toDateString(cellValue, 'yyyy/MM/dd')
    },
    getHeight() {
      this.height = window.innerHeight - 200
    },
    format (val) {
      this.monthList= [] ;
      var date = new Date(val); //时间戳为10位需*1000，时间戳为13位的话不需乘1000
      var M = (date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1);
      // this.queryParam.beginTime=Y+M;
      this.monthList.push(M);

      date.setMonth(date.getMonth()+1);
      M = (date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1) ;
      this.monthList.push(M)

      date.setMonth(date.getMonth()+1);
      M = (date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1) ;
      this.monthList.push(M)

      date.setMonth(date.getMonth()+1);
      var Y = date.getFullYear() + "/";
      M = (date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1)+ "/";
      var D = date.getDate()<10?  "0" +date.getDate():date.getDate();
      // var h = date.getHours() + ":";
      // var m = date.getMinutes() + ":";
      // var s = (date.getSeconds() < 10 ? "0" + (date.getSeconds()) : date.getSeconds());
      // return Y + M + D + h + m + s;
      this.queryParam.endTime=Y + M + D;
      // return Y + M ;
    }
  }
}
</script>
<style lang="scss" scoped >

.el-header{margin:0;padding: 5px;height:auto;
  .el-input{
    width: 140px;
  }
  .el-select{
    width: 140px;
  }

}
.el-container{padding: 0;margin:0;}
.el-main{padding: 0;}
.el-col{padding: 0;height: 32px;}
.el-aside{background: #fff;padding: 0}
.el-container{padding: 0}
.el-row {}
.el-row:last-child {margin-bottom: 0; }

.tableStyles{
  background: #0a76a4;
}

.my-dropdown {
  width: 400px;
  height: 400px;
  background-color: #fff;
  border: 1px solid #dcdfe6;
  box-shadow: 0 0 6px 2px rgba(0, 0, 0, 0.1);
  font-size: 12px;

}
.mytable1{

}
.borderClass{

}
.vxe-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.el-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.keyword-lighten {
  color: #000;
  background-color: #FFFF00;
}

.vxe-textarea--inner {
  line-height: inherit;
}
.el-form-item__label-wrap {
  margin-left: 0px !important;
  float: left;
}
.fontClass{
  font-size: 12px;
  font-weight: bold;
}


</style>
